

package com.zcloud.modules.sys.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.zcloud.modules.sys.entity.SysMenuEntity;

import java.util.List;


/**
 * 菜单管理
 *
 *
 */
public interface SysMenuService extends IService<SysMenuEntity> {

	/**
	 * 根据父菜单，查询子菜单
	 * @param parentId 父菜单ID
	 * @param menuIdList  用户菜单ID
	 */
	List<SysMenuEntity> queryListParentId(Integer parentId, List<Integer> menuIdList);

	/**
	 * 根据父菜单，查询子菜单
	 * @param parentId 父菜单ID
	 */
	List<SysMenuEntity> queryListParentId(Integer parentId);

	/**
	 * 获取不包含按钮的菜单列表
	 */
	List<SysMenuEntity> queryNotButtonList(Integer parentId);

	/**
	 * 获取用户菜单列表
	 */
	List<SysMenuEntity> getUserMenuList(String userId);

	/**
	 * 删除
	 */
	void delete(Integer menuId);

	/**
	 * 获取全部菜单列表
	 */
    List<SysMenuEntity> getAllList(Integer parentId);

	/**
	 * 获取全部菜单列表
	 */
	List<SysMenuEntity> getAllListNotButton(Integer parentId);
}
