package com.zcloud.util.personnelPositioning;


public interface OpenAPI {
    /**
     * openapi对外暴露的path与公有服务⼀致，path以/rest开头。加签认证时以rest进⾏
     加签认证
     */
    String EXTERNAL_PREFIX = "/rest/";
    /**
     * 专有服务内部实现以/openapi开头。加签认证时以rest进⾏加签认证
     */
    String INTERNAL_PREFIX = "/openapi/";
    /**
     * sik认证⽅式
     */
    String KEY_TYPE_SIK = "/sik/";
    /**
     * 组织管理接⼝
     */
    String FINDS_ORG_CREATE = "finds.org.create";
    String FINDS_ORG_UPDATE = "finds.org.update";
    String FINDS_ORG_DELETE = "finds.org.delete";
    /**
     * 终端相关
     */
    String FINDS_TERMINAL_CREATE = "finds.terminal.create";
    String FINDS_TERMINAL_DELETE = "finds.terminal.delete";
    String FINDS_TERMINAL_UPDATE = "finds.terminal.update";
    String FINDS_TERMINAL_QUERY = "finds.terminal.query";
    String FINDS_TERMINAL_LIST = "finds.terminal.list";
    String FINDS_TERMINAL_CONTROL = "finds.terminal.control";

    String FINDS_FENCE_CREATE = "finds.fence.create";
    String FINDS_FENCE_DELETE = "finds.fence.delete";
    String FINDS_FENCE_UPDATE = "finds.fence.update";
    String FINDS_FENCE_QUERY = "finds.fence.query";
    String FINDS_FENCE_LIST = "finds.fence.list";
    /**
     * 位置相关
     */
    String FINDS_POINT_LOCATE = "finds.point.locate";
    String FINDS_POINT_TRACE = "finds.point.trace";
    String FINDS_POINT_ADD = "finds.point.add";
    /**
     * 告警规则接⼝
     */
    String FINDS_ALARM_RULE_CREATE = "finds.alarm.rule.create";
    String FINDS_ALARM_RULE_UPDATE = "finds.alarm.rule.update";
    String FINDS_ALARM_RULE_DELETE = "finds.alarm.rule.delete";
    String FINDS_ALARM_RULE_LIST = "finds.alarm.rule.list";
    String FINDS_ALARM_RULE_QUERY = "finds.alarm.rule.query";
    /**
     * 告警相关
     */
    String FINDS_ALARM_LIST = "finds.alarm.list";
    /**
     * ⼈员管理
     */
    String FINDS_TRACK_STAFF_CREATE = "finds.staff.create";
    String FINDS_TRACK_STAFF_UPDATE = "finds.staff.update";
    String FINDS_TRACK_STAFF_DELETE = "finds.staff.delete";
    String FINDS_TRACK_STAFF_LIST = "finds.staff.list";

    /**
     * 实体和可追踪对象 - 绑定
     */
    String FINDS_TRACK_TERMINAL_BIND = "finds.track.terminal.bind";
    String FINDS_TRACK_TERMINAL_UNBIND = "finds.track.terminal.unbind";
}
